"use strict";

var language = 'en';
var id_function = "btn-diagnostics-test";
var list_query_touch_pad;
var status_tests;
var status_test;
var tests_touchpad;
var notification_updates;
var notification_update;

fetch('/locales/language_common.json')
  .then(response => response.json())
  .then(data => {
    list_query_touch_pad = data["list_query_touch_pad"];
    status_tests = data["status_tests"];
    notification_updates = data["notification_updates"];
    fetch('footer.html')
      .then(response => response.text())
      .then(html => {
        id_function = "btn-diagnostics-test";
        let parser = new DOMParser();
        let parsedContent = parser.parseFromString(html, 'text/html');
        document.getElementById('footer-container').appendChild(parsedContent.body);
        const color = "#00ccff"
        if (location.pathname == "/system_info.html") {
          document.getElementById('system-info').style["color"] = color;
        }
        else if (location.pathname == "/") {
          document.getElementById('diagnostics-test').style["color"] = color;
        }
        else if (location.pathname == "/app_info.html") {
          document.getElementById('app-info').style["color"] = color;
        }
        loadLanguage();
      })
      .catch(error => console.error('Error fetching HTML file:', error));
  })

function changeLanguage() {
  var selectedLanguage = document.getElementById('lang-select').value;
  localStorage.setItem("language", selectedLanguage);
  status_test = status_tests[selectedLanguage];
  tests_touchpad = list_query_touch_pad[selectedLanguage];
  notification_update = notification_updates[selectedLanguage];
  getDataLanguage(selectedLanguage)
    .then(data => updateContent(data))
    .catch(error => {
      console.error('Error:', error);
    });
}

async function getDataLanguage(selectedLanguage) {
  try {
    const response = await fetch(`/locales/${selectedLanguage}.json`);
    const data = await response.json();
    document.getElementById("btn-guide").href = "./guide-" + selectedLanguage + ".html";
    return data;
  } catch (error) {
    console.error('Error fetching language data:', error);
    throw error;
  }
}

function loadLanguage() {
  language = localStorage.getItem("language");
  if (language == null) {
    language = navigator.language;
    if (language.includes('en')) {
      language = "en";
    }
    // todo: we will comment it to support mutil language
    language = "en";
    localStorage.setItem("language", language);
  }
  var selected_element = document.getElementById('lang-select');
  selected_element.value = language;
  changeLanguage();
}

function updateContent(data) {
  document.querySelectorAll('[data-translate]').forEach(link => {
    const key = link.getAttribute('data-translate');
    link.textContent = data[key];
  });
}

document.body.style["height"] = (screen.height * 0.8) + "px";
