"use strict";

var cacheName = 'chromeos-service-tool';
var filesToCache = [
  '/',
  '/css/guide.css',
  '/css/audio.css',
  '/css/touch.css',
  '/css/home.css',
  '/css/touchpad.css',
  '/css/style.css',
  'manifest.json',
  'guide-ko.html',
  'stylus.html',
  '/js/system_info.js',
  '/js/stylus.js',
  '/js/touchscreen.js',
  '/js/footer_guide.js',
  '/js/lcd.js',
  '/js/footer.js',
  '/js/touch_common.js',
  '/js/main.js',
  '/js/common.js',
  '/js/touchpad.js',
  '/locales/ko.json',
  '/locales/language_common.json',
  '/locales/vi.json',
  '/locales/en.json',
  'system_info.html',
  'footer_guide.html',
  'touchscreen.html',
  'sw.js',
  'app_info.html',
  'index.html',
  'touchpad.html',
  'guide-en.html',
  'test_audio.html',
  '/resources/Right_9.wav',
  '/resources/test.mp3',
  '/resources/Left_9.wav',
  'lcd.html',
  '/images/down.png',
  '/images/Pixel.PNG',
  '/images/Button1.PNG',
  '/images/SDCard1.PNG',
  '/images/Button2.PNG',
  '/images/SDCard2.PNG',
  '/images/Bluetooth2.PNG',
  '/images/TypeC.PNG',
  '/images/icon_320.png',
  '/images/TypeA.PNG',
  '/images/icon_512.png',
  '/images/Sensor.PNG',
  '/images/icon_256.png',
  '/images/TroubleShooting.PNG',
  '/images/icon_192.png',
  '/images/Home.png',
  '/images/microSDCard.PNG',
  '/images/Backlight.PNG',
  '/images/SettingsIcon.PNG',
  '/images/icon_152.png',
  '/images/icon_128.png',
  '/images/icon_144.png',
  '/images/icon.ico',
  '/images/Wifi2.PNG',
  '/images/Bluetooth1.PNG',
  '/images/Brightness.PNG',
  '/images/Wifi1.PNG',
  '/images/Accelerometer.PNG',
  'footer.html',
  'guide-vi.html'
];

window.onload = () => {
  if ('serviceWorker' in navigator) {
    navigator.serviceWorker
      .register('./sw.js');

    fetch('version.json')
      .then(response => response.json())
      .then(data => {
        console.log(data);
        const version_local = localStorage.getItem("version");
        if (version_local != data["version"]) {
          setTimeout(requireUpdate, 500, data["version"]);
        }
      })
      .catch((err) => {
        console.log("Have err:" + err);
      })
  }
}

function showLoadingInstall() {
  console.log("Start installing...");
  const loading = document.getElementById("loading-container");
  const main_content = document.getElementById("main-content");
  loading.style.display = 'flex';
  main_content.style.display = 'none';
}

function hideLoadingInstall() {
  console.log("End installing...");
  const loading = document.getElementById("loading-container");
  const main_content = document.getElementById("main-content");
  loading.style.display = 'none';
  main_content.style.display = 'block';
}

window.addEventListener('appinstalled', (event) => {
  console.log('App installed successfully!');
  updateCache();
});

function updateCache() {
  caches.open(cacheName).then((cache) => {
    console.log("Save all cache");
    showLoadingInstall();
    cache.addAll(filesToCache).then(() => {
      console.log('Cache successfully populated');
      hideLoadingInstall();
    })
      .catch((error) => {
        console.error('Error adding requests to the cache:', error);
      });
  })
}

function requireUpdate(version) {
  const response = window.confirm(notification_update);
  if (response) {
    console.log("OK");
    localStorage.setItem("version", version);
    updateCache();
  }
  else {
    console.log("Cancel");
  }
}