"use strict";

const btn_start = document.getElementById("btn-start");
const btn_click = document.getElementById("click-test");
const query = document.getElementById("query-test-touchpad");
const scroll_element = document.getElementById("scroll");
const element_test_scroll = document.getElementById("element-test-scroll");
const right_guide = document.getElementById("right-guide");
const EVENT_TWO_FINGERS = 2;
const EVENT_ONE_FINGER = 0;
var language = 'en';
var div_test_touchpad = document.getElementById("test-touch-pad")
var countNumber = 0;
var start_test = false;
btn_start.style['display'] = "inline-block";
var time_click = 3;
element_test_scroll.style["marginTop"] = `${scroll_element.offsetHeight}px`;

btn_click.addEventListener('mousedown', function (event) {
  if (event.button === EVENT_TWO_FINGERS && countNumber == 1) {
    //two-finger
    time_click--;
    if (time_click == 0) {
      countNumber++;
      time_click = 1;
    }
  }
  if (event.button === EVENT_ONE_FINGER && countNumber == 0) {
    //one-finger;
    time_click--;
    if (time_click == 0) {
      countNumber++;
      time_click = 3;
    }
  }
  query.innerText = tests_touchpad[countNumber] + ": " + time_click;
});

function EndTestTouchpad() {
  scroll_element.removeEventListener("scroll", CheckScroll);
  document.removeEventListener("scroll", CheckScroll);
  right_guide.removeEventListener("scroll", CheckScroll);
  btn_start.style['display'] = "inline-block";
  div_test_touchpad.style['display'] = "none";
  document.body.removeEventListener('contextmenu', preventContextMenu);
  alert(status_test["title"] +": "+ status_test["pass"]);
}

function preventContextMenu(event) {
  event.preventDefault();
}

function StartTestTouchpad() {
  scroll_element.addEventListener("scroll", CheckScroll);
  document.addEventListener("scroll", CheckScroll);
  right_guide.addEventListener("scroll", CheckScroll);
  start_test = true;
  time_click = 3;
  countNumber = 0;
  btn_start.style['display'] = "none";
  div_test_touchpad.style['display'] = "block";
  scroll_element.scrollTop = 0;
  query.innerText = tests_touchpad[countNumber] + ": " + time_click;
  document.body.addEventListener('contextmenu', preventContextMenu);
}

btn_start.addEventListener("click", StartTestTouchpad);

window.onload = () => {
  div_test_touchpad.style['display'] = "none"
}

//Overide function from footer.js
function updateContent(data) {
  document.querySelectorAll('[data-translate]').forEach(link => {
    const key = link.getAttribute('data-translate');
    link.textContent = data[key];
  });
  query.innerText = tests_touchpad[countNumber] + ": " + time_click;
}

function CheckScroll(event) {
  if (countNumber == 2) {
    setTimeout(EndTestTouchpad,500);
    countNumber++;
  }
}

