var cacheName = 'chromeos-service-tool';

/* Start the service worker and cache all of the app's content */
self.addEventListener('install', (event) => {
    console.log("[Service Worker] Install");
});

self.addEventListener('activate', function (event) {
    console.log("[Service Worker] activate");
});

/* Serve cached content when offline */
self.addEventListener('fetch', (event) => {

    // Run in cache first and get data from network to save.
    if (event.request.url.includes(self.location.origin)) {
        event.respondWith(
            caches.match(event.request).then((cacheResponse) => {
                const networkFetch = fetch(event.request).then((response) => {
                    const responseClone = response.clone();
                    caches.open(cacheName).then((cache) => {
                        cache.put(event.request, responseClone);
                    })
                    return response;
                }).catch(function (reason) {
                    console.error("Can't fetch data from "+event.request.url);
                });
                return cacheResponse || networkFetch;
            })
        );
    }
    else {
        event.respondWidth(fetch(event.request));
    }

    // Only run offline
    // event.respondWith(caches.match(event.request));
});
